Package org.apache.tapestry5.jpa.modules

## Class JpaModule

- java.lang.Object
- - org.apache.tapestry5.jpa.modules.JpaModule

-     public class JpaModule
      extends java.lang.Object

  Defines core services for JPA support.
  Since:
    5.3

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `JpaModule()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static void` | `bind​(ServiceBinder binder)` |
    `static EntityManagerManager` | `buildEntityManagerManager​(EntityManagerSource entityManagerSource, PerthreadManager perthreadManager, org.slf4j.Logger logger)` |
    `static JpaEntityPackageManager` | `buildJpaEntityPackageManager​(java.util.Collection<java.lang.String> packageNames)` |
    `static void` | `provideApplicationStateContributions​(MappedConfiguration<java.lang.Class,​ApplicationStateContribution> configuration, EntityManagerSource entityManagerSource, boolean entitySessionStatePersistenceStrategyEnabled)` |
    `void` | `provideApplicationStatePersistenceStrategies​(MappedConfiguration<java.lang.String,​ApplicationStatePersistenceStrategy> configuration)` |
    `static void` | `provideClassTransformWorkers​(OrderedConfiguration<ComponentClassTransformWorker2> configuration)` |
    `static void` | `provideEntityPackages​(Configuration<java.lang.String> configuration, java.lang.String appRootPackage)` |
    `static void` | `provideEntityPersistentFieldStrategies​(MappedConfiguration<java.lang.String,​PersistentFieldStrategy> configuration)` |
    `static void` | `provideFactoryDefaults​(MappedConfiguration<java.lang.String,​java.lang.String> configuration)` |
    `static void` | `provideObjectProviders​(OrderedConfiguration<ObjectProvider> configuration)` |
    `static void` | `provideValueEncoders​(MappedConfiguration<java.lang.Class,​ValueEncoderFactory> configuration, boolean provideEncoders, EntityManagerSource entityManagerSource, EntityManagerManager entityManagerManager, TypeCoercer typeCoercer, PropertyAccess propertyAccess, LoggerSource loggerSource)` |
    `static void` | `startupEarly​(EntityManagerManager entityManagerManager, boolean earlyStartup)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### JpaModule

          public JpaModule()

  - ### Method Detail

    - #### bind

          public static void bind​(ServiceBinder binder)

    - #### buildJpaEntityPackageManager

          public static JpaEntityPackageManager buildJpaEntityPackageManager​(java.util.Collection<java.lang.String> packageNames)

    - #### buildEntityManagerManager

          @Scope("perthread")
          public static EntityManagerManager buildEntityManagerManager​(EntityManagerSource entityManagerSource,
                                                                       PerthreadManager perthreadManager,
                                                                       org.slf4j.Logger logger)

    - #### provideEntityPackages

          @Contribute(JpaEntityPackageManager.class)
          public static void provideEntityPackages​(Configuration<java.lang.String> configuration,
                                                   @Symbol("tapestry.app-package")
                                                   java.lang.String appRootPackage)

    - #### provideEntityPersistentFieldStrategies

          @Contribute(PersistentFieldManager.class)
          public static void provideEntityPersistentFieldStrategies​(MappedConfiguration<java.lang.String,​PersistentFieldStrategy> configuration)

    - #### provideApplicationStatePersistenceStrategies

          @Contribute(ApplicationStatePersistenceStrategySource.class)
          public void provideApplicationStatePersistenceStrategies​(MappedConfiguration<java.lang.String,​ApplicationStatePersistenceStrategy> configuration)

    - #### provideClassTransformWorkers

          @Contribute(ComponentClassTransformWorker2.class)
          @Primary
          public static void provideClassTransformWorkers​(OrderedConfiguration<ComponentClassTransformWorker2> configuration)

    - #### provideObjectProviders

          @Contribute(MasterObjectProvider.class)
          public static void provideObjectProviders​(OrderedConfiguration<ObjectProvider> configuration)

    - #### provideFactoryDefaults

          @Contribute(SymbolProvider.class)
          @FactoryDefaults
          public static void provideFactoryDefaults​(MappedConfiguration<java.lang.String,​java.lang.String> configuration)

    - #### provideValueEncoders

          @Contribute(ValueEncoderSource.class)
          public static void provideValueEncoders​(MappedConfiguration<java.lang.Class,​ValueEncoderFactory> configuration,
                                                  @Symbol("tapestry.jpa.provide-entity-value-encoders")
                                                  boolean provideEncoders,
                                                  EntityManagerSource entityManagerSource,
                                                  EntityManagerManager entityManagerManager,
                                                  TypeCoercer typeCoercer,
                                                  PropertyAccess propertyAccess,
                                                  LoggerSource loggerSource)

    - #### provideApplicationStateContributions

          @Contribute(ApplicationStateManager.class)
          public static void provideApplicationStateContributions​(MappedConfiguration<java.lang.Class,​ApplicationStateContribution> configuration,
                                                                  EntityManagerSource entityManagerSource,
                                                                  @Symbol("tapestry.jpa.entity-session-state-persistence-strategy-enabled")
                                                                  boolean entitySessionStatePersistenceStrategyEnabled)

    - #### startupEarly

          @Startup
          public static void startupEarly​(EntityManagerManager entityManagerManager,
                                          @Symbol("tapestry.jpa.early-startup")
                                          boolean earlyStartup)